/* A Bison parser, made by GNU Bison 2.5.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 27 "src/xkbcomp/parser.y"

#include "xkbcomp-priv.h"
#include "parseutils.h"

#pragma GCC diagnostic ignored "-Wredundant-decls"

extern int yylex(union YYSTYPE *val, struct YYLTYPE *loc, void *scanner);

static void
yyerror(struct YYLTYPE *loc, struct parser_param *param, const char *msg)
{
    scanner_error(loc, param->scanner, msg);
}

#define scanner param->scanner


/* Line 268 of yacc.c  */
#line 89 "src/xkbcomp/parser.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END_OF_FILE = 0,
     ERROR_TOK = 255,
     XKB_KEYMAP = 1,
     XKB_KEYCODES = 2,
     XKB_TYPES = 3,
     XKB_SYMBOLS = 4,
     XKB_COMPATMAP = 5,
     XKB_GEOMETRY = 6,
     XKB_SEMANTICS = 7,
     XKB_LAYOUT = 8,
     INCLUDE = 10,
     OVERRIDE = 11,
     AUGMENT = 12,
     REPLACE = 13,
     ALTERNATE = 14,
     VIRTUAL_MODS = 20,
     TYPE = 21,
     INTERPRET = 22,
     ACTION_TOK = 23,
     KEY = 24,
     ALIAS = 25,
     GROUP = 26,
     MODIFIER_MAP = 27,
     INDICATOR = 28,
     SHAPE = 29,
     KEYS = 30,
     ROW = 31,
     SECTION = 32,
     OVERLAY = 33,
     TEXT = 34,
     OUTLINE = 35,
     SOLID = 36,
     LOGO = 37,
     VIRTUAL = 38,
     EQUALS = 40,
     PLUS = 41,
     MINUS = 42,
     DIVIDE = 43,
     TIMES = 44,
     OBRACE = 45,
     CBRACE = 46,
     OPAREN = 47,
     CPAREN = 48,
     OBRACKET = 49,
     CBRACKET = 50,
     DOT = 51,
     COMMA = 52,
     SEMI = 53,
     EXCLAM = 54,
     INVERT = 55,
     STRING = 60,
     INTEGER = 61,
     FLOAT = 62,
     IDENT = 63,
     KEYNAME = 64,
     PARTIAL = 70,
     DEFAULT = 71,
     HIDDEN = 72,
     ALPHANUMERIC_KEYS = 73,
     MODIFIER_KEYS = 74,
     KEYPAD_KEYS = 75,
     FUNCTION_KEYS = 76,
     ALTERNATE_GROUP = 77
   };
#endif
/* Tokens.  */
#define END_OF_FILE 0
#define ERROR_TOK 255
#define XKB_KEYMAP 1
#define XKB_KEYCODES 2
#define XKB_TYPES 3
#define XKB_SYMBOLS 4
#define XKB_COMPATMAP 5
#define XKB_GEOMETRY 6
#define XKB_SEMANTICS 7
#define XKB_LAYOUT 8
#define INCLUDE 10
#define OVERRIDE 11
#define AUGMENT 12
#define REPLACE 13
#define ALTERNATE 14
#define VIRTUAL_MODS 20
#define TYPE 21
#define INTERPRET 22
#define ACTION_TOK 23
#define KEY 24
#define ALIAS 25
#define GROUP 26
#define MODIFIER_MAP 27
#define INDICATOR 28
#define SHAPE 29
#define KEYS 30
#define ROW 31
#define SECTION 32
#define OVERLAY 33
#define TEXT 34
#define OUTLINE 35
#define SOLID 36
#define LOGO 37
#define VIRTUAL 38
#define EQUALS 40
#define PLUS 41
#define MINUS 42
#define DIVIDE 43
#define TIMES 44
#define OBRACE 45
#define CBRACE 46
#define OPAREN 47
#define CPAREN 48
#define OBRACKET 49
#define CBRACKET 50
#define DOT 51
#define COMMA 52
#define SEMI 53
#define EXCLAM 54
#define INVERT 55
#define STRING 60
#define INTEGER 61
#define FLOAT 62
#define IDENT 63
#define KEYNAME 64
#define PARTIAL 70
#define DEFAULT 71
#define HIDDEN 72
#define ALPHANUMERIC_KEYS 73
#define MODIFIER_KEYS 74
#define KEYPAD_KEYS 75
#define FUNCTION_KEYS 76
#define ALTERNATE_GROUP 77




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 295 of yacc.c  */
#line 122 "src/xkbcomp/parser.y"

        int              ival;
        unsigned         uval;
        int64_t          num;
        enum xkb_file_type file_type;
        char            *str;
        char            keyName[XkbKeyNameLength];
        xkb_atom_t      sval;
        enum merge_mode merge;
        ParseCommon     *any;
        ExprDef         *expr;
        VarDef          *var;
        VModDef         *vmod;
        InterpDef       *interp;
        KeyTypeDef      *keyType;
        SymbolsDef      *syms;
        ModMapDef       *modMask;
        GroupCompatDef  *groupCompat;
        IndicatorMapDef *ledMap;
        IndicatorNameDef *ledName;
        KeycodeDef      *keyCode;
        KeyAliasDef     *keyAlias;
        void            *geom;
        XkbFile         *file;



/* Line 295 of yacc.c  */
#line 291 "src/xkbcomp/parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 345 of yacc.c  */
#line 316 "src/xkbcomp/parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  18
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   774

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  75
/* YYNRULES -- Number of rules.  */
#define YYNRULES  188
/* YYNRULES -- Number of states.  */
#define YYNSTATES  341

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   257

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     4,     5,     6,     7,     8,     9,    10,    11,     2,
      12,    13,    14,    15,    16,     2,     2,     2,     2,     2,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,     2,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,     2,     2,     2,     2,
      52,    53,    54,    55,    56,     2,     2,     2,     2,     2,
      57,    58,    59,    60,    61,    62,    63,    64,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     1,     2
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    12,    14,    22,    24,
      26,    28,    31,    33,    41,    46,    48,    50,    52,    54,
      56,    58,    59,    62,    64,    66,    68,    70,    72,    74,
      76,    78,    80,    83,    84,    87,    90,    93,    96,    99,
     102,   105,   108,   111,   114,   117,   120,   123,   126,   129,
     134,   137,   141,   146,   152,   156,   160,   162,   164,   168,
     175,   179,   181,   184,   186,   193,   200,   204,   206,   207,
     211,   215,   217,   220,   222,   226,   230,   236,   243,   250,
     256,   263,   270,   277,   284,   287,   289,   295,   297,   299,
     301,   303,   306,   308,   314,   316,   320,   322,   324,   328,
     335,   339,   341,   345,   349,   351,   355,   361,   365,   369,
     371,   377,   384,   386,   388,   390,   392,   394,   396,   398,
     400,   402,   404,   406,   408,   410,   412,   414,   416,   418,
     420,   421,   423,   425,   427,   429,   431,   433,   434,   438,
     440,   444,   448,   452,   456,   460,   462,   465,   468,   471,
     474,   476,   481,   483,   487,   491,   493,   498,   500,   504,
     509,   516,   518,   520,   522,   524,   526,   527,   531,   535,
     537,   539,   543,   545,   547,   549,   552,   554,   556,   558,
     560,   562,   564,   566,   568,   570,   572,   574,   575
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      66,     0,    -1,    67,    -1,    70,    -1,    72,    -1,    67,
      68,    -1,    68,    -1,    74,    69,   138,    41,    70,    42,
      49,    -1,     4,    -1,    10,    -1,    11,    -1,    70,    71,
      -1,    71,    -1,    74,    73,   138,    41,    77,    42,    49,
      -1,    74,    73,   138,    77,    -1,     5,    -1,     6,    -1,
       8,    -1,     7,    -1,     9,    -1,    75,    -1,    -1,    75,
      76,    -1,    76,    -1,    57,    -1,    58,    -1,    59,    -1,
      60,    -1,    61,    -1,    62,    -1,    63,    -1,    64,    -1,
      77,    78,    -1,    -1,   116,    79,    -1,   116,    82,    -1,
     116,    85,    -1,   116,    80,    -1,   116,    81,    -1,   116,
      88,    -1,   116,    89,    -1,   116,    94,    -1,   116,    93,
      -1,   116,    95,    -1,   116,    96,    -1,   116,    97,    -1,
     116,    98,    -1,   116,   112,    -1,   117,    52,    -1,   124,
      36,   120,    49,    -1,   136,    49,    -1,    50,   136,    49,
      -1,   135,    36,   134,    49,    -1,    22,   135,    36,   135,
      49,    -1,    17,    83,    49,    -1,    83,    48,    84,    -1,
      84,    -1,   136,    -1,   136,    36,   120,    -1,    19,    86,
      41,    87,    42,    49,    -1,   129,    37,   120,    -1,   129,
      -1,    87,    79,    -1,    79,    -1,    18,   137,    41,    87,
      42,    49,    -1,    21,   135,    41,    90,    42,    49,    -1,
      90,    48,    91,    -1,    91,    -1,    -1,   124,    36,   120,
      -1,   124,    36,    92,    -1,   136,    -1,    50,   136,    -1,
      92,    -1,    45,   126,    46,    -1,    45,   122,    46,    -1,
      23,   133,    36,   120,    49,    -1,    24,   136,    41,   119,
      42,    49,    -1,    25,   137,    41,    87,    42,    49,    -1,
      25,   133,    36,   120,    49,    -1,    35,    25,   133,    36,
     120,    49,    -1,    26,   137,    41,   108,    42,    49,    -1,
      26,   137,    41,   110,    42,    49,    -1,    29,   137,    41,
      99,    42,    49,    -1,    99,   100,    -1,   100,    -1,    28,
      41,   101,    42,    49,    -1,    79,    -1,   112,    -1,    95,
      -1,   105,    -1,   101,   102,    -1,   102,    -1,    27,    41,
     103,    42,    49,    -1,    79,    -1,   103,    48,   104,    -1,
     104,    -1,   135,    -1,    41,   119,    42,    -1,    30,   137,
      41,   106,    42,    49,    -1,   106,    48,   107,    -1,   107,
      -1,   135,    36,   135,    -1,   108,    48,   109,    -1,   109,
      -1,    41,   110,    42,    -1,   136,    36,    41,   110,    42,
      -1,   136,    36,   120,    -1,   110,    48,   111,    -1,   111,
      -1,    45,   130,    48,   130,    46,    -1,   113,   137,    41,
      87,    42,    49,    -1,    31,    -1,    32,    -1,    33,    -1,
      34,    -1,   136,    -1,   115,    -1,    20,    -1,    19,    -1,
      18,    -1,    21,    -1,    23,    -1,    24,    -1,    25,    -1,
      26,    -1,    28,    -1,    29,    -1,    31,    -1,   117,    -1,
      -1,    12,    -1,    14,    -1,    13,    -1,    15,    -1,    16,
      -1,   119,    -1,    -1,   119,    48,   120,    -1,   120,    -1,
     120,    39,   120,    -1,   120,    37,   120,    -1,   120,    38,
     120,    -1,   120,    40,   120,    -1,   124,    36,   120,    -1,
     121,    -1,    38,   121,    -1,    37,   121,    -1,    50,   121,
      -1,    51,   121,    -1,   124,    -1,   114,    43,   118,    44,
      -1,   125,    -1,    43,   120,    44,    -1,   122,    48,   123,
      -1,   123,    -1,   114,    43,   118,    44,    -1,   114,    -1,
     114,    47,   114,    -1,   114,    45,   120,    46,    -1,   114,
      47,   114,    45,   120,    46,    -1,   137,    -1,   133,    -1,
     132,    -1,   135,    -1,   127,    -1,    -1,   127,    48,   129,
      -1,   127,    48,   128,    -1,   129,    -1,   128,    -1,    41,
     127,    42,    -1,    55,    -1,    29,    -1,   133,    -1,    38,
     131,    -1,   131,    -1,    54,    -1,    53,    -1,    54,    -1,
      53,    -1,    53,    -1,    56,    -1,    55,    -1,    58,    -1,
      52,    -1,   139,    -1,    -1,    52,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   179,   179,   181,   183,   187,   189,   193,   199,   200,
     201,   204,   211,   215,   230,   244,   245,   246,   247,   248,
     251,   252,   255,   256,   259,   260,   261,   262,   263,   264,
     265,   266,   269,   271,   274,   279,   284,   289,   294,   299,
     304,   309,   314,   319,   324,   329,   330,   331,   332,   339,
     341,   343,   347,   351,   355,   359,   361,   365,   367,   371,
     377,   379,   383,   385,   389,   395,   401,   403,   405,   408,
     409,   410,   411,   412,   415,   417,   421,   425,   429,   433,
     435,   439,   441,   445,   449,   450,   453,   455,   457,   459,
     461,   465,   466,   469,   470,   474,   475,   478,   480,   484,
     488,   489,   492,   495,   497,   501,   503,   505,   509,   511,
     515,   519,   523,   524,   525,   526,   529,   530,   533,   535,
     537,   539,   541,   543,   545,   547,   549,   551,   553,   557,
     558,   561,   562,   563,   564,   565,   575,   576,   579,   581,
     585,   587,   589,   591,   593,   595,   599,   601,   603,   605,
     607,   609,   611,   613,   617,   619,   623,   627,   634,   642,
     651,   662,   669,   676,   680,   689,   690,   693,   695,   697,
     699,   703,   707,   708,   709,   723,   724,   727,   728,   731,
     734,   737,   740,   743,   744,   747,   750,   751,   754
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "END_OF_FILE", "error", "$undefined", "ERROR_TOK", "XKB_KEYMAP",
  "XKB_KEYCODES", "XKB_TYPES", "XKB_SYMBOLS", "XKB_COMPATMAP",
  "XKB_GEOMETRY", "XKB_SEMANTICS", "XKB_LAYOUT", "INCLUDE", "OVERRIDE",
  "AUGMENT", "REPLACE", "ALTERNATE", "VIRTUAL_MODS", "TYPE", "INTERPRET",
  "ACTION_TOK", "KEY", "ALIAS", "GROUP", "MODIFIER_MAP", "INDICATOR",
  "SHAPE", "KEYS", "ROW", "SECTION", "OVERLAY", "TEXT", "OUTLINE", "SOLID",
  "LOGO", "VIRTUAL", "EQUALS", "PLUS", "MINUS", "DIVIDE", "TIMES",
  "OBRACE", "CBRACE", "OPAREN", "CPAREN", "OBRACKET", "CBRACKET", "DOT",
  "COMMA", "SEMI", "EXCLAM", "INVERT", "STRING", "INTEGER", "FLOAT",
  "IDENT", "KEYNAME", "PARTIAL", "DEFAULT", "HIDDEN", "ALPHANUMERIC_KEYS",
  "MODIFIER_KEYS", "KEYPAD_KEYS", "FUNCTION_KEYS", "ALTERNATE_GROUP",
  "$accept", "XkbFile", "XkbCompMapList", "XkbCompositeMap",
  "XkbCompositeType", "XkbMapConfigList", "XkbMapConfig", "XkbConfig",
  "FileType", "OptFlags", "Flags", "Flag", "DeclList", "Decl", "VarDecl",
  "KeyNameDecl", "KeyAliasDecl", "VModDecl", "VModDefList", "VModDef",
  "InterpretDecl", "InterpretMatch", "VarDeclList", "KeyTypeDecl",
  "SymbolsDecl", "SymbolsBody", "SymbolsVarDecl", "ArrayInit",
  "GroupCompatDecl", "ModMapDecl", "IndicatorMapDecl", "IndicatorNameDecl",
  "ShapeDecl", "SectionDecl", "SectionBody", "SectionBodyItem", "RowBody",
  "RowBodyItem", "Keys", "Key", "OverlayDecl", "OverlayKeyList",
  "OverlayKey", "OutlineList", "OutlineInList", "CoordList", "Coord",
  "DoodadDecl", "DoodadType", "FieldSpec", "Element", "OptMergeMode",
  "MergeMode", "OptExprList", "ExprList", "Expr", "Term", "ActionList",
  "Action", "Lhs", "Terminal", "OptKeySymList", "KeySymList", "KeySyms",
  "KeySym", "SignedNumber", "Number", "Float", "Integer", "KeyCode",
  "KeyName", "Ident", "String", "OptMapName", "MapName", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   255,     1,     2,     3,     4,     5,     6,
       7,     8,    10,    11,    12,    13,    14,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    60,    61,    62,    63,    64,    70,    71,    72,
      73,    74,    75,    76,    77
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    65,    66,    66,    66,    67,    67,    68,    69,    69,
      69,    70,    70,    71,    72,    73,    73,    73,    73,    73,
      74,    74,    75,    75,    76,    76,    76,    76,    76,    76,
      76,    76,    77,    77,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    79,
      79,    79,    80,    81,    82,    83,    83,    84,    84,    85,
      86,    86,    87,    87,    88,    89,    90,    90,    90,    91,
      91,    91,    91,    91,    92,    92,    93,    94,    95,    96,
      96,    97,    97,    98,    99,    99,   100,   100,   100,   100,
     100,   101,   101,   102,   102,   103,   103,   104,   104,   105,
     106,   106,   107,   108,   108,   109,   109,   109,   110,   110,
     111,   112,   113,   113,   113,   113,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   116,
     116,   117,   117,   117,   117,   117,   118,   118,   119,   119,
     120,   120,   120,   120,   120,   120,   121,   121,   121,   121,
     121,   121,   121,   121,   122,   122,   123,   124,   124,   124,
     124,   125,   125,   125,   125,   126,   126,   127,   127,   127,
     127,   128,   129,   129,   129,   130,   130,   131,   131,   132,
     133,   134,   135,   136,   136,   137,   138,   138,   139
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     7,     1,     1,
       1,     2,     1,     7,     4,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     4,
       2,     3,     4,     5,     3,     3,     1,     1,     3,     6,
       3,     1,     2,     1,     6,     6,     3,     1,     0,     3,
       3,     1,     2,     1,     3,     3,     5,     6,     6,     5,
       6,     6,     6,     6,     2,     1,     5,     1,     1,     1,
       1,     2,     1,     5,     1,     3,     1,     1,     3,     6,
       3,     1,     3,     3,     1,     3,     5,     3,     3,     1,
       5,     6,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     3,     1,
       3,     3,     3,     3,     3,     1,     2,     2,     2,     2,
       1,     4,     1,     3,     3,     1,     4,     1,     3,     4,
       6,     1,     1,     1,     1,     1,     0,     3,     3,     1,
       1,     3,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      21,    24,    25,    26,    27,    28,    29,    30,    31,     0,
      21,     6,    21,    12,     4,     0,    20,    23,     1,     5,
       0,    11,     0,     8,    15,    16,    18,    17,    19,     9,
      10,   187,   187,    22,   187,   188,     0,   186,    33,     0,
      21,    33,   130,    21,   130,   131,   133,   132,   134,   135,
      32,     0,   129,     0,     0,     0,   120,   119,   118,   121,
       0,   122,   123,   124,   125,   126,   127,   128,   113,   114,
     115,     0,     0,   183,   182,   184,    34,    37,    38,    35,
      36,    39,    40,    42,    41,    43,    44,    45,    46,    47,
       0,   157,   117,     0,     0,   116,    48,     7,    13,     0,
      56,    57,   185,     0,   173,   180,   172,     0,    61,   174,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    50,     0,    54,     0,     0,
       0,     0,    68,     0,     0,     0,     0,     0,     0,     0,
       0,    51,     0,   120,   119,   121,   122,   123,   124,   125,
     127,   128,     0,     0,     0,     0,     0,   179,   157,     0,
     145,   150,   152,   163,   162,   164,   116,   161,   158,     0,
     181,     0,    55,    58,    63,     0,     0,    60,   166,     0,
       0,    67,    73,     0,   116,     0,     0,     0,   139,     0,
       0,     0,     0,     0,   104,     0,   109,     0,   124,   126,
       0,    87,    89,     0,    85,    90,    88,     0,     0,   147,
     150,   146,     0,   148,   149,   137,     0,     0,     0,     0,
     159,     0,     0,    49,    52,     0,    62,     0,   173,     0,
     172,     0,     0,   155,     0,   165,   170,   169,    72,     0,
       0,     0,    53,    76,     0,     0,    79,     0,     0,     0,
     178,   177,     0,   176,     0,     0,     0,     0,     0,     0,
       0,     0,    84,     0,     0,   153,     0,   136,   141,   142,
     140,   143,   144,     0,    64,    59,     0,   137,    75,     0,
      74,     0,    65,    66,    70,    69,    77,   138,    78,   105,
     175,     0,    81,   103,    82,   108,     0,   107,     0,    94,
       0,    92,     0,    83,    80,   111,   151,   160,   171,     0,
     154,   168,   167,     0,     0,     0,     0,    91,     0,   101,
       0,   156,   110,   106,     0,     0,    96,    97,    86,     0,
       0,     0,     0,     0,     0,    99,   100,   102,    98,    93,
      95
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     9,    10,    11,    31,    12,    13,    14,    32,    22,
      16,    17,    42,    50,   174,    77,    78,    79,    99,   100,
      80,   107,   175,    81,    82,   180,   181,   182,    83,    84,
     202,    86,    87,    88,   203,   204,   300,   301,   325,   326,
     205,   318,   319,   193,   194,   195,   196,   206,    90,   158,
      92,    51,    52,   266,   267,   188,   160,   232,   233,   161,
     162,   234,   235,   236,   237,   252,   253,   163,   164,   171,
     165,   166,   167,    36,    37
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -180
static const yytype_int16 yypact[] =
{
     235,  -180,  -180,  -180,  -180,  -180,  -180,  -180,  -180,    43,
      11,  -180,    78,  -180,  -180,   303,   235,  -180,  -180,  -180,
     155,  -180,   280,  -180,  -180,  -180,  -180,  -180,  -180,  -180,
    -180,    -1,    -1,  -180,    -1,  -180,    39,  -180,    54,    54,
     235,  -180,   219,   139,    41,  -180,  -180,  -180,  -180,  -180,
    -180,   315,     7,    56,    62,    70,    77,     8,  -180,    87,
      87,    91,    70,   -34,    77,  -180,    77,   102,  -180,  -180,
    -180,   144,    70,  -180,  -180,  -180,  -180,  -180,  -180,  -180,
    -180,  -180,  -180,  -180,  -180,  -180,  -180,  -180,  -180,  -180,
      77,   117,  -180,   136,   147,   137,  -180,  -180,  -180,    18,
    -180,   154,  -180,   153,  -180,  -180,  -180,   168,   176,  -180,
     186,   180,   193,   196,   203,   209,   211,   213,    91,   200,
     222,   420,    21,   420,   212,  -180,    70,  -180,   420,   716,
     716,   420,   547,    87,   420,   420,   420,   716,    57,   502,
     233,  -180,   716,  -180,  -180,  -180,  -180,  -180,  -180,  -180,
    -180,  -180,   420,   420,   420,   420,   420,  -180,   161,   221,
    -180,   234,  -180,  -180,  -180,  -180,  -180,  -180,   259,   111,
    -180,   229,  -180,   314,  -180,   562,   590,   314,   605,    70,
     -27,  -180,  -180,   283,    16,   271,   138,    48,   314,   204,
     646,   281,   -24,   140,  -180,   220,  -180,   309,    77,   319,
      77,  -180,  -180,   461,  -180,  -180,  -180,   420,   661,  -180,
    -180,  -180,   184,  -180,  -180,   420,   420,   420,   420,   420,
    -180,   420,   420,  -180,  -180,   306,  -180,   323,   325,    36,
     331,   334,    40,  -180,   332,   336,  -180,  -180,  -180,   330,
     547,   338,  -180,  -180,   333,   420,  -180,   337,   224,    79,
    -180,  -180,   339,  -180,   346,    63,   352,   281,   379,   702,
     344,   357,  -180,   208,   360,  -180,   367,   364,   -16,   -16,
    -180,  -180,   314,   236,  -180,  -180,   242,   420,  -180,    21,
    -180,    36,  -180,  -180,  -180,   314,  -180,   314,  -180,  -180,
    -180,   -24,  -180,  -180,  -180,  -180,   281,   314,   372,  -180,
     519,  -180,    87,  -180,  -180,  -180,  -180,  -180,  -180,   370,
    -180,  -180,  -180,   369,   273,   -25,   374,  -180,   274,  -180,
     382,  -180,  -180,  -180,   420,   275,  -180,  -180,  -180,   375,
      87,    87,   276,   376,   -25,  -180,  -180,  -180,  -180,  -180,
    -180
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -180,  -180,  -180,   409,  -180,   340,    -8,  -180,   399,    38,
    -180,   410,   386,  -180,   -19,  -180,  -180,  -180,  -180,   302,
    -180,  -180,  -117,  -180,  -180,  -180,   202,   195,  -180,  -180,
     396,  -180,  -180,  -180,  -180,   247,  -180,   152,  -180,   119,
    -180,  -180,   124,  -180,   201,  -179,   198,   408,  -180,   -23,
    -180,  -180,  -180,   183,  -132,    84,   175,  -180,   182,   -29,
    -180,  -180,   237,   181,   -55,   173,   216,  -180,   -56,  -180,
     -51,   -45,   -30,   159,  -180
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -184
static const yytype_int16 yytable[] =
{
      94,   109,   108,   187,    21,   112,    95,   114,   110,   111,
     101,    -2,   248,   176,   249,   239,   324,   113,   102,   105,
     190,   240,    93,   218,   219,   208,   103,   119,    91,   250,
     251,    74,    76,   115,   116,    21,   117,   104,    15,   143,
     144,    58,   145,    18,   146,   147,   148,   149,    20,    65,
     150,    35,   151,    45,    46,    47,    48,    49,   -71,    96,
     120,   105,   140,   106,   -71,   104,   126,   127,     1,     2,
       3,     4,     5,     6,     7,     8,    73,   229,    -3,    75,
      40,   101,   185,    54,    95,    95,   278,   184,   279,   105,
     244,   106,    95,   197,    95,    41,   245,    95,   191,   168,
      93,    93,   192,   183,   191,    97,    91,    91,    93,    91,
      93,    98,    73,    93,    91,    75,    91,   314,    73,    91,
     201,    75,   109,   210,   210,    73,   210,   210,    75,   102,
      95,    95,   250,   251,   238,     1,     2,     3,     4,     5,
       6,     7,     8,    74,   105,    95,    93,    93,   216,   217,
     218,   219,    91,    91,  -112,   231,   226,   226,    95,    23,
     223,    93,   121,    95,   122,    29,    30,    91,   115,   118,
     260,   226,   123,   109,    93,   216,   217,   218,   219,    93,
      91,    53,   254,   124,   201,    91,   125,   243,   255,   226,
     128,    38,   332,    39,   129,   184,     1,     2,     3,     4,
       5,     6,     7,     8,   215,   159,   121,   169,   122,   130,
     197,   183,   173,   131,    95,   177,   133,    91,   186,   -14,
     189,   216,   217,   218,   219,   109,   312,   132,   265,   134,
      93,    45,    46,    47,    48,    49,    91,   135,   212,   136,
     299,   216,   217,   218,   219,   216,   217,   218,   219,   141,
     137,   320,   138,   246,   139,    95,   231,   304,   216,   217,
     218,   219,   256,   142,   327,   170,   289,   220,   257,   207,
     221,    93,   257,   216,   217,   218,   219,    91,   224,   320,
     337,   299,   307,   327,   308,    24,    25,    26,    27,    28,
     281,   263,     1,     2,     3,     4,     5,     6,     7,     8,
     268,   269,   270,   271,   222,   272,   273,    23,    24,    25,
      26,    27,    28,    29,    30,   323,   329,   333,   338,   241,
     242,   257,   330,   334,   245,   285,   192,   209,   211,   287,
     213,   214,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,   297,    65,    66,   258,    67,    68,    69,    70,
      71,   216,   217,   218,   219,   274,   143,   144,    58,   145,
     259,   146,   147,   148,   149,    72,    65,   150,  -127,   151,
      73,    74,   275,    75,  -183,   152,   153,   277,   280,   282,
      43,   154,   286,   178,   281,   302,   288,   291,   155,   156,
     102,   105,   157,    73,    74,   292,    75,   143,   144,    58,
     145,   294,   146,   147,   148,   149,   303,    65,   150,   305,
     151,   306,   245,   315,   321,   322,   152,   153,   331,    19,
     296,    34,   154,   328,   335,   339,    33,    44,   172,   155,
     156,   102,   105,   157,    73,    74,   284,    75,   143,   144,
      58,   145,   283,   146,   147,   148,   149,    85,    65,   150,
     262,   151,   317,   340,   336,   295,   293,   152,   153,    89,
     309,   310,   311,   154,   313,   290,   276,     0,     0,     0,
     155,   156,   102,   105,   157,    73,    74,     0,    75,   143,
     144,    58,   145,     0,   146,   147,   198,   149,     0,   199,
     150,   200,    67,    68,    69,    70,     0,     0,     0,     0,
       0,     0,     0,   261,     0,     0,     0,     0,     0,     0,
       0,    72,     0,     0,     0,     0,    73,     0,     0,    75,
     143,   144,    58,   145,     0,   146,   147,   198,   149,     0,
     199,   150,   200,    67,    68,    69,    70,   143,   144,    58,
     145,     0,   146,   147,   148,   149,   298,    65,   150,     0,
     151,     0,    72,     0,     0,     0,     0,    73,     0,     0,
      75,   316,     0,     0,     0,   143,   144,    58,   145,    72,
     146,   147,   148,   149,    73,    65,   150,    75,   151,     0,
     143,   144,    58,   145,     0,   146,   147,   148,   149,     0,
      65,   150,   178,   151,     0,     0,     0,   179,     0,     0,
       0,     0,    73,     0,   225,    75,     0,     0,   143,   144,
      58,   145,    72,   146,   147,   148,   149,    73,    65,   150,
      75,   151,     0,   143,   144,    58,   145,     0,   146,   147,
     148,   149,   227,    65,   228,     0,   151,     0,     0,     0,
      72,     0,     0,     0,     0,    73,   229,     0,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   105,     0,
     230,     0,     0,    75,   143,   144,    58,   145,     0,   146,
     147,   148,   149,     0,    65,   150,     0,   151,     0,   143,
     144,    58,   145,     0,   146,   147,   148,   149,   247,    65,
     150,     0,   151,     0,     0,     0,    72,     0,     0,     0,
       0,    73,     0,   264,    75,     0,     0,     0,     0,     0,
       0,    72,     0,     0,     0,     0,    73,     0,     0,    75,
     143,   144,    58,   145,     0,   146,   147,   148,   149,   298,
      65,   150,     0,   151,   143,   144,    58,   145,     0,   146,
     147,   148,   149,     0,    65,   150,     0,   151,     0,     0,
       0,     0,    72,     0,     0,     0,     0,    73,     0,     0,
      75,     0,     0,     0,     0,     0,    72,     0,     0,     0,
       0,    73,     0,     0,    75
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-180))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      51,    57,    57,   135,    12,    61,    51,    63,    59,    60,
      55,     0,   191,   130,    38,    42,    41,    62,    52,    53,
     137,    48,    51,    39,    40,   142,    56,    72,    51,    53,
      54,    56,    51,    63,    64,    43,    66,    29,     0,    18,
      19,    20,    21,     0,    23,    24,    25,    26,    10,    28,
      29,    52,    31,    12,    13,    14,    15,    16,    42,    52,
      90,    53,   118,    55,    48,    29,    48,    49,    57,    58,
      59,    60,    61,    62,    63,    64,    55,    41,     0,    58,
      41,   126,   133,    42,   129,   130,    46,   132,    48,    53,
      42,    55,   137,   138,   139,    41,    48,   142,    41,   122,
     129,   130,    45,   132,    41,    49,   129,   130,   137,   132,
     139,    49,    55,   142,   137,    58,   139,   296,    55,   142,
     139,    58,   178,   152,   153,    55,   155,   156,    58,    52,
     175,   176,    53,    54,   179,    57,    58,    59,    60,    61,
      62,    63,    64,    56,    53,   190,   175,   176,    37,    38,
      39,    40,   175,   176,    52,   178,   175,   176,   203,     4,
      49,   190,    45,   208,    47,    10,    11,   190,   198,    25,
     200,   190,    36,   229,   203,    37,    38,    39,    40,   208,
     203,    42,    42,    36,   203,   208,    49,    49,    48,   208,
      36,    32,   324,    34,    41,   240,    57,    58,    59,    60,
      61,    62,    63,    64,    43,   121,    45,   123,    47,    41,
     255,   240,   128,    37,   259,   131,    36,   240,   134,     0,
     136,    37,    38,    39,    40,   281,   281,    41,    44,    36,
     259,    12,    13,    14,    15,    16,   259,    41,   154,    36,
     259,    37,    38,    39,    40,    37,    38,    39,    40,    49,
      41,   302,    41,    49,    41,   300,   279,    49,    37,    38,
      39,    40,    42,    41,   315,    53,    42,    46,    48,    36,
      36,   300,    48,    37,    38,    39,    40,   300,    49,   330,
     331,   300,    46,   334,    42,     5,     6,     7,     8,     9,
      48,   207,    57,    58,    59,    60,    61,    62,    63,    64,
     216,   217,   218,   219,    45,   221,   222,     4,     5,     6,
       7,     8,     9,    10,    11,    42,    42,    42,    42,    36,
      49,    48,    48,    48,    48,   241,    45,   152,   153,   245,
     155,   156,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,   258,    28,    29,    36,    31,    32,    33,    34,
      35,    37,    38,    39,    40,    49,    18,    19,    20,    21,
      41,    23,    24,    25,    26,    50,    28,    29,    43,    31,
      55,    56,    49,    58,    43,    37,    38,    43,    46,    49,
      40,    43,    49,    45,    48,    41,    49,    48,    50,    51,
      52,    53,    54,    55,    56,    49,    58,    18,    19,    20,
      21,    49,    23,    24,    25,    26,    49,    28,    29,    49,
      31,    44,    48,    41,    44,    46,    37,    38,    36,    10,
      41,    22,    43,    49,    49,    49,    16,    41,   126,    50,
      51,    52,    53,    54,    55,    56,   241,    58,    18,    19,
      20,    21,   240,    23,    24,    25,    26,    51,    28,    29,
     203,    31,   300,   334,   330,   257,   255,    37,    38,    51,
     277,   279,   281,    43,   291,   249,   229,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    -1,    28,
      29,    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    58,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    -1,
      28,    29,    30,    31,    32,    33,    34,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      58,    42,    -1,    -1,    -1,    18,    19,    20,    21,    50,
      23,    24,    25,    26,    55,    28,    29,    58,    31,    -1,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    -1,
      28,    29,    45,    31,    -1,    -1,    -1,    50,    -1,    -1,
      -1,    -1,    55,    -1,    42,    58,    -1,    -1,    18,    19,
      20,    21,    50,    23,    24,    25,    26,    55,    28,    29,
      58,    31,    -1,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    42,    28,    29,    -1,    31,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    55,    41,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,    -1,
      55,    -1,    -1,    58,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    -1,    28,    29,    -1,    31,    -1,    18,
      19,    20,    21,    -1,    23,    24,    25,    26,    42,    28,
      29,    -1,    31,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    55,    -1,    42,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    58,
      18,    19,    20,    21,    -1,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    -1,    28,    29,    -1,    31,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    58
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    57,    58,    59,    60,    61,    62,    63,    64,    66,
      67,    68,    70,    71,    72,    74,    75,    76,     0,    68,
      74,    71,    74,     4,     5,     6,     7,     8,     9,    10,
      11,    69,    73,    76,    73,    52,   138,   139,   138,   138,
      41,    41,    77,    70,    77,    12,    13,    14,    15,    16,
      78,   116,   117,    42,    42,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    28,    29,    31,    32,    33,
      34,    35,    50,    55,    56,    58,    79,    80,    81,    82,
      85,    88,    89,    93,    94,    95,    96,    97,    98,   112,
     113,   114,   115,   124,   135,   136,    52,    49,    49,    83,
      84,   136,    52,   137,    29,    53,    55,    86,   129,   133,
     135,   135,   133,   136,   133,   137,   137,   137,    25,   136,
     137,    45,    47,    36,    36,    49,    48,    49,    36,    41,
      41,    37,    41,    36,    36,    41,    36,    41,    41,    41,
     133,    49,    41,    18,    19,    21,    23,    24,    25,    26,
      29,    31,    37,    38,    43,    50,    51,    54,   114,   120,
     121,   124,   125,   132,   133,   135,   136,   137,   114,   120,
      53,   134,    84,   120,    79,    87,    87,   120,    45,    50,
      90,    91,    92,   124,   136,   135,   120,   119,   120,   120,
      87,    41,    45,   108,   109,   110,   111,   136,    25,    28,
      30,    79,    95,    99,   100,   105,   112,    36,    87,   121,
     124,   121,   120,   121,   121,    43,    37,    38,    39,    40,
      46,    36,    45,    49,    49,    42,    79,    42,    29,    41,
      55,   114,   122,   123,   126,   127,   128,   129,   136,    42,
      48,    36,    49,    49,    42,    48,    49,    42,   110,    38,
      53,    54,   130,   131,    42,    48,    42,    48,    36,    41,
     137,    42,   100,   120,    42,    44,   118,   119,   120,   120,
     120,   120,   120,   120,    49,    49,   127,    43,    46,    48,
      46,    48,    49,    91,    92,   120,    49,   120,    49,    42,
     131,    48,    49,   109,    49,   111,    41,   120,    27,    79,
     101,   102,    41,    49,    49,    49,    44,    46,    42,   118,
     123,   128,   129,   130,   110,    41,    42,   102,   106,   107,
     135,    44,    46,    42,    41,   103,   104,   135,    49,    42,
      48,    36,   119,    42,    48,    49,   107,   135,    42,    49,
     104
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, param, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, scanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, param); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct parser_param *param)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, param)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    struct parser_param *param;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (param);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct parser_param *param)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, param)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    struct parser_param *param;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, param);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, struct parser_param *param)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, param)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    struct parser_param *param;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , param);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, param); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct parser_param *param)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, param)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    struct parser_param *param;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (param);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (struct parser_param *param);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (struct parser_param *param)
#else
int
yyparse (param)
    struct parser_param *param;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1810 of yacc.c  */
#line 180 "src/xkbcomp/parser.y"
    { (yyval.file) = param->rtrn = (yyvsp[(1) - (1)].file); }
    break;

  case 3:

/* Line 1810 of yacc.c  */
#line 182 "src/xkbcomp/parser.y"
    { (yyval.file) = param->rtrn = (yyvsp[(1) - (1)].file); }
    break;

  case 4:

/* Line 1810 of yacc.c  */
#line 184 "src/xkbcomp/parser.y"
    { (yyval.file) = param->rtrn = (yyvsp[(1) - (1)].file); }
    break;

  case 5:

/* Line 1810 of yacc.c  */
#line 188 "src/xkbcomp/parser.y"
    { (yyval.file) = (XkbFile *)AppendStmt(&(yyvsp[(1) - (2)].file)->common, &(yyvsp[(2) - (2)].file)->common); }
    break;

  case 6:

/* Line 1810 of yacc.c  */
#line 190 "src/xkbcomp/parser.y"
    { (yyval.file) = (yyvsp[(1) - (1)].file); }
    break;

  case 7:

/* Line 1810 of yacc.c  */
#line 196 "src/xkbcomp/parser.y"
    { (yyval.file) = CreateXKBFile(param->ctx, (yyvsp[(2) - (7)].file_type), (yyvsp[(3) - (7)].str), &(yyvsp[(5) - (7)].file)->common, (yyvsp[(1) - (7)].uval)); }
    break;

  case 8:

/* Line 1810 of yacc.c  */
#line 199 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_KEYMAP; }
    break;

  case 9:

/* Line 1810 of yacc.c  */
#line 200 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_KEYMAP; }
    break;

  case 10:

/* Line 1810 of yacc.c  */
#line 201 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_KEYMAP; }
    break;

  case 11:

/* Line 1810 of yacc.c  */
#line 205 "src/xkbcomp/parser.y"
    {
                            if (!(yyvsp[(2) - (2)].file))
                                (yyval.file) = (yyvsp[(1) - (2)].file);
                            else
                                (yyval.file) = (XkbFile *)AppendStmt(&(yyvsp[(1) - (2)].file)->common, &(yyvsp[(2) - (2)].file)->common);
                        }
    break;

  case 12:

/* Line 1810 of yacc.c  */
#line 212 "src/xkbcomp/parser.y"
    { (yyval.file) = (yyvsp[(1) - (1)].file); }
    break;

  case 13:

/* Line 1810 of yacc.c  */
#line 218 "src/xkbcomp/parser.y"
    {
                            if ((yyvsp[(2) - (7)].file_type) == FILE_TYPE_GEOMETRY) {
                                free((yyvsp[(3) - (7)].str));
                                FreeStmt((yyvsp[(5) - (7)].any));
                                (yyval.file) = NULL;
                            }
                            else {
                                (yyval.file) = CreateXKBFile(param->ctx, (yyvsp[(2) - (7)].file_type), (yyvsp[(3) - (7)].str), (yyvsp[(5) - (7)].any), (yyvsp[(1) - (7)].uval));
                            }
                        }
    break;

  case 14:

/* Line 1810 of yacc.c  */
#line 231 "src/xkbcomp/parser.y"
    {
                            if ((yyvsp[(2) - (4)].file_type) == FILE_TYPE_GEOMETRY) {
                                free((yyvsp[(3) - (4)].str));
                                FreeStmt((yyvsp[(4) - (4)].any));
                                (yyval.file) = NULL;
                            }
                            else {
                                (yyval.file) = CreateXKBFile(param->ctx, (yyvsp[(2) - (4)].file_type), (yyvsp[(3) - (4)].str), (yyvsp[(4) - (4)].any), (yyvsp[(1) - (4)].uval));
                            }
                        }
    break;

  case 15:

/* Line 1810 of yacc.c  */
#line 244 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_KEYCODES; }
    break;

  case 16:

/* Line 1810 of yacc.c  */
#line 245 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_TYPES; }
    break;

  case 17:

/* Line 1810 of yacc.c  */
#line 246 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_COMPAT; }
    break;

  case 18:

/* Line 1810 of yacc.c  */
#line 247 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_SYMBOLS; }
    break;

  case 19:

/* Line 1810 of yacc.c  */
#line 248 "src/xkbcomp/parser.y"
    { (yyval.file_type) = FILE_TYPE_GEOMETRY; }
    break;

  case 20:

/* Line 1810 of yacc.c  */
#line 251 "src/xkbcomp/parser.y"
    { (yyval.uval) = (yyvsp[(1) - (1)].uval); }
    break;

  case 21:

/* Line 1810 of yacc.c  */
#line 252 "src/xkbcomp/parser.y"
    { (yyval.uval) = 0; }
    break;

  case 22:

/* Line 1810 of yacc.c  */
#line 255 "src/xkbcomp/parser.y"
    { (yyval.uval) = ((yyvsp[(1) - (2)].uval) | (yyvsp[(2) - (2)].uval)); }
    break;

  case 23:

/* Line 1810 of yacc.c  */
#line 256 "src/xkbcomp/parser.y"
    { (yyval.uval) = (yyvsp[(1) - (1)].uval); }
    break;

  case 24:

/* Line 1810 of yacc.c  */
#line 259 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_Partial; }
    break;

  case 25:

/* Line 1810 of yacc.c  */
#line 260 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_Default; }
    break;

  case 26:

/* Line 1810 of yacc.c  */
#line 261 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_Hidden; }
    break;

  case 27:

/* Line 1810 of yacc.c  */
#line 262 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_AlphanumericKeys; }
    break;

  case 28:

/* Line 1810 of yacc.c  */
#line 263 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_ModifierKeys; }
    break;

  case 29:

/* Line 1810 of yacc.c  */
#line 264 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_KeypadKeys; }
    break;

  case 30:

/* Line 1810 of yacc.c  */
#line 265 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_FunctionKeys; }
    break;

  case 31:

/* Line 1810 of yacc.c  */
#line 266 "src/xkbcomp/parser.y"
    { (yyval.uval) = XkbLC_AlternateGroup; }
    break;

  case 32:

/* Line 1810 of yacc.c  */
#line 270 "src/xkbcomp/parser.y"
    { (yyval.any) = AppendStmt((yyvsp[(1) - (2)].any), (yyvsp[(2) - (2)].any)); }
    break;

  case 33:

/* Line 1810 of yacc.c  */
#line 271 "src/xkbcomp/parser.y"
    { (yyval.any) = NULL; }
    break;

  case 34:

/* Line 1810 of yacc.c  */
#line 275 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].var)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].var)->common;
                        }
    break;

  case 35:

/* Line 1810 of yacc.c  */
#line 280 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].vmod)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].vmod)->common;
                        }
    break;

  case 36:

/* Line 1810 of yacc.c  */
#line 285 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].interp)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].interp)->common;
                        }
    break;

  case 37:

/* Line 1810 of yacc.c  */
#line 290 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].keyCode)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].keyCode)->common;
                        }
    break;

  case 38:

/* Line 1810 of yacc.c  */
#line 295 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].keyAlias)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].keyAlias)->common;
                        }
    break;

  case 39:

/* Line 1810 of yacc.c  */
#line 300 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].keyType)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].keyType)->common;
                        }
    break;

  case 40:

/* Line 1810 of yacc.c  */
#line 305 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].syms)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].syms)->common;
                        }
    break;

  case 41:

/* Line 1810 of yacc.c  */
#line 310 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].modMask)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].modMask)->common;
                        }
    break;

  case 42:

/* Line 1810 of yacc.c  */
#line 315 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].groupCompat)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].groupCompat)->common;
                        }
    break;

  case 43:

/* Line 1810 of yacc.c  */
#line 320 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].ledMap)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].ledMap)->common;
                        }
    break;

  case 44:

/* Line 1810 of yacc.c  */
#line 325 "src/xkbcomp/parser.y"
    {
                            (yyvsp[(2) - (2)].ledName)->merge = (yyvsp[(1) - (2)].merge);
                            (yyval.any) = &(yyvsp[(2) - (2)].ledName)->common;
                        }
    break;

  case 45:

/* Line 1810 of yacc.c  */
#line 329 "src/xkbcomp/parser.y"
    { }
    break;

  case 46:

/* Line 1810 of yacc.c  */
#line 330 "src/xkbcomp/parser.y"
    { }
    break;

  case 47:

/* Line 1810 of yacc.c  */
#line 331 "src/xkbcomp/parser.y"
    { }
    break;

  case 48:

/* Line 1810 of yacc.c  */
#line 333 "src/xkbcomp/parser.y"
    {
                            (yyval.any) = &IncludeCreate(param->ctx, (yyvsp[(2) - (2)].str), (yyvsp[(1) - (2)].merge))->common;
                            free((yyvsp[(2) - (2)].str));
                        }
    break;

  case 49:

/* Line 1810 of yacc.c  */
#line 340 "src/xkbcomp/parser.y"
    { (yyval.var) = VarCreate((yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); }
    break;

  case 50:

/* Line 1810 of yacc.c  */
#line 342 "src/xkbcomp/parser.y"
    { (yyval.var) = BoolVarCreate((yyvsp[(1) - (2)].sval), 1); }
    break;

  case 51:

/* Line 1810 of yacc.c  */
#line 344 "src/xkbcomp/parser.y"
    { (yyval.var) = BoolVarCreate((yyvsp[(2) - (3)].sval), 0); }
    break;

  case 52:

/* Line 1810 of yacc.c  */
#line 348 "src/xkbcomp/parser.y"
    { (yyval.keyCode) = KeycodeCreate((yyvsp[(1) - (4)].keyName), (yyvsp[(3) - (4)].uval)); }
    break;

  case 53:

/* Line 1810 of yacc.c  */
#line 352 "src/xkbcomp/parser.y"
    { (yyval.keyAlias) = KeyAliasCreate((yyvsp[(2) - (5)].keyName), (yyvsp[(4) - (5)].keyName)); }
    break;

  case 54:

/* Line 1810 of yacc.c  */
#line 356 "src/xkbcomp/parser.y"
    { (yyval.vmod) = (yyvsp[(2) - (3)].vmod); }
    break;

  case 55:

/* Line 1810 of yacc.c  */
#line 360 "src/xkbcomp/parser.y"
    { (yyval.vmod) = (VModDef *)AppendStmt(&(yyvsp[(1) - (3)].vmod)->common, &(yyvsp[(3) - (3)].vmod)->common); }
    break;

  case 56:

/* Line 1810 of yacc.c  */
#line 362 "src/xkbcomp/parser.y"
    { (yyval.vmod) = (yyvsp[(1) - (1)].vmod); }
    break;

  case 57:

/* Line 1810 of yacc.c  */
#line 366 "src/xkbcomp/parser.y"
    { (yyval.vmod) = VModCreate((yyvsp[(1) - (1)].sval), NULL); }
    break;

  case 58:

/* Line 1810 of yacc.c  */
#line 368 "src/xkbcomp/parser.y"
    { (yyval.vmod) = VModCreate((yyvsp[(1) - (3)].sval), (yyvsp[(3) - (3)].expr)); }
    break;

  case 59:

/* Line 1810 of yacc.c  */
#line 374 "src/xkbcomp/parser.y"
    { (yyvsp[(2) - (6)].interp)->def = (yyvsp[(4) - (6)].var); (yyval.interp) = (yyvsp[(2) - (6)].interp); }
    break;

  case 60:

/* Line 1810 of yacc.c  */
#line 378 "src/xkbcomp/parser.y"
    { (yyval.interp) = InterpCreate((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].expr)); }
    break;

  case 61:

/* Line 1810 of yacc.c  */
#line 380 "src/xkbcomp/parser.y"
    { (yyval.interp) = InterpCreate((yyvsp[(1) - (1)].str), NULL); }
    break;

  case 62:

/* Line 1810 of yacc.c  */
#line 384 "src/xkbcomp/parser.y"
    { (yyval.var) = (VarDef *)AppendStmt(&(yyvsp[(1) - (2)].var)->common, &(yyvsp[(2) - (2)].var)->common); }
    break;

  case 63:

/* Line 1810 of yacc.c  */
#line 386 "src/xkbcomp/parser.y"
    { (yyval.var) = (yyvsp[(1) - (1)].var); }
    break;

  case 64:

/* Line 1810 of yacc.c  */
#line 392 "src/xkbcomp/parser.y"
    { (yyval.keyType) = KeyTypeCreate((yyvsp[(2) - (6)].sval), (yyvsp[(4) - (6)].var)); }
    break;

  case 65:

/* Line 1810 of yacc.c  */
#line 398 "src/xkbcomp/parser.y"
    { (yyval.syms) = SymbolsCreate((yyvsp[(2) - (6)].keyName), (ExprDef *)(yyvsp[(4) - (6)].var)); }
    break;

  case 66:

/* Line 1810 of yacc.c  */
#line 402 "src/xkbcomp/parser.y"
    { (yyval.var) = (VarDef *)AppendStmt(&(yyvsp[(1) - (3)].var)->common, &(yyvsp[(3) - (3)].var)->common); }
    break;

  case 67:

/* Line 1810 of yacc.c  */
#line 404 "src/xkbcomp/parser.y"
    { (yyval.var) = (yyvsp[(1) - (1)].var); }
    break;

  case 68:

/* Line 1810 of yacc.c  */
#line 405 "src/xkbcomp/parser.y"
    { (yyval.var) = NULL; }
    break;

  case 69:

/* Line 1810 of yacc.c  */
#line 408 "src/xkbcomp/parser.y"
    { (yyval.var) = VarCreate((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 70:

/* Line 1810 of yacc.c  */
#line 409 "src/xkbcomp/parser.y"
    { (yyval.var) = VarCreate((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 71:

/* Line 1810 of yacc.c  */
#line 410 "src/xkbcomp/parser.y"
    { (yyval.var) = BoolVarCreate((yyvsp[(1) - (1)].sval), 1); }
    break;

  case 72:

/* Line 1810 of yacc.c  */
#line 411 "src/xkbcomp/parser.y"
    { (yyval.var) = BoolVarCreate((yyvsp[(2) - (2)].sval), 0); }
    break;

  case 73:

/* Line 1810 of yacc.c  */
#line 412 "src/xkbcomp/parser.y"
    { (yyval.var) = VarCreate(NULL, (yyvsp[(1) - (1)].expr)); }
    break;

  case 74:

/* Line 1810 of yacc.c  */
#line 416 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 75:

/* Line 1810 of yacc.c  */
#line 418 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateUnary(EXPR_ACTION_LIST, EXPR_TYPE_ACTION, (yyvsp[(2) - (3)].expr)); }
    break;

  case 76:

/* Line 1810 of yacc.c  */
#line 422 "src/xkbcomp/parser.y"
    { (yyval.groupCompat) = GroupCompatCreate((yyvsp[(2) - (5)].ival), (yyvsp[(4) - (5)].expr)); }
    break;

  case 77:

/* Line 1810 of yacc.c  */
#line 426 "src/xkbcomp/parser.y"
    { (yyval.modMask) = ModMapCreate((yyvsp[(2) - (6)].sval), (yyvsp[(4) - (6)].expr)); }
    break;

  case 78:

/* Line 1810 of yacc.c  */
#line 430 "src/xkbcomp/parser.y"
    { (yyval.ledMap) = IndicatorMapCreate((yyvsp[(2) - (6)].sval), (yyvsp[(4) - (6)].var)); }
    break;

  case 79:

/* Line 1810 of yacc.c  */
#line 434 "src/xkbcomp/parser.y"
    { (yyval.ledName) = IndicatorNameCreate((yyvsp[(2) - (5)].ival), (yyvsp[(4) - (5)].expr), false); }
    break;

  case 80:

/* Line 1810 of yacc.c  */
#line 436 "src/xkbcomp/parser.y"
    { (yyval.ledName) = IndicatorNameCreate((yyvsp[(3) - (6)].ival), (yyvsp[(5) - (6)].expr), true); }
    break;

  case 81:

/* Line 1810 of yacc.c  */
#line 440 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 82:

/* Line 1810 of yacc.c  */
#line 442 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 83:

/* Line 1810 of yacc.c  */
#line 446 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 84:

/* Line 1810 of yacc.c  */
#line 449 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL;}
    break;

  case 85:

/* Line 1810 of yacc.c  */
#line 450 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 86:

/* Line 1810 of yacc.c  */
#line 454 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 87:

/* Line 1810 of yacc.c  */
#line 456 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(1) - (1)].var)->common); (yyval.geom) = NULL; }
    break;

  case 88:

/* Line 1810 of yacc.c  */
#line 458 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 89:

/* Line 1810 of yacc.c  */
#line 460 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(1) - (1)].ledMap)->common); (yyval.geom) = NULL; }
    break;

  case 90:

/* Line 1810 of yacc.c  */
#line 462 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 91:

/* Line 1810 of yacc.c  */
#line 465 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL;}
    break;

  case 92:

/* Line 1810 of yacc.c  */
#line 466 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 93:

/* Line 1810 of yacc.c  */
#line 469 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 94:

/* Line 1810 of yacc.c  */
#line 471 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(1) - (1)].var)->common); (yyval.geom) = NULL; }
    break;

  case 95:

/* Line 1810 of yacc.c  */
#line 474 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 96:

/* Line 1810 of yacc.c  */
#line 475 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 97:

/* Line 1810 of yacc.c  */
#line 479 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 98:

/* Line 1810 of yacc.c  */
#line 481 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(2) - (3)].expr)->common); (yyval.geom) = NULL; }
    break;

  case 99:

/* Line 1810 of yacc.c  */
#line 485 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 100:

/* Line 1810 of yacc.c  */
#line 488 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 101:

/* Line 1810 of yacc.c  */
#line 489 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 102:

/* Line 1810 of yacc.c  */
#line 492 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 103:

/* Line 1810 of yacc.c  */
#line 496 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL;}
    break;

  case 104:

/* Line 1810 of yacc.c  */
#line 498 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 105:

/* Line 1810 of yacc.c  */
#line 502 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 106:

/* Line 1810 of yacc.c  */
#line 504 "src/xkbcomp/parser.y"
    { (yyval.geom) = NULL; }
    break;

  case 107:

/* Line 1810 of yacc.c  */
#line 506 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(3) - (3)].expr)->common); (yyval.geom) = NULL; }
    break;

  case 108:

/* Line 1810 of yacc.c  */
#line 510 "src/xkbcomp/parser.y"
    { (yyval.expr) = NULL; }
    break;

  case 109:

/* Line 1810 of yacc.c  */
#line 512 "src/xkbcomp/parser.y"
    { (yyval.expr) = NULL; }
    break;

  case 110:

/* Line 1810 of yacc.c  */
#line 516 "src/xkbcomp/parser.y"
    { (yyval.expr) = NULL; }
    break;

  case 111:

/* Line 1810 of yacc.c  */
#line 520 "src/xkbcomp/parser.y"
    { FreeStmt(&(yyvsp[(4) - (6)].var)->common); (yyval.geom) = NULL; }
    break;

  case 112:

/* Line 1810 of yacc.c  */
#line 523 "src/xkbcomp/parser.y"
    { (yyval.uval) = 0; }
    break;

  case 113:

/* Line 1810 of yacc.c  */
#line 524 "src/xkbcomp/parser.y"
    { (yyval.uval) = 0; }
    break;

  case 114:

/* Line 1810 of yacc.c  */
#line 525 "src/xkbcomp/parser.y"
    { (yyval.uval) = 0; }
    break;

  case 115:

/* Line 1810 of yacc.c  */
#line 526 "src/xkbcomp/parser.y"
    { (yyval.uval) = 0; }
    break;

  case 116:

/* Line 1810 of yacc.c  */
#line 529 "src/xkbcomp/parser.y"
    { (yyval.sval) = (yyvsp[(1) - (1)].sval); }
    break;

  case 117:

/* Line 1810 of yacc.c  */
#line 530 "src/xkbcomp/parser.y"
    { (yyval.sval) = (yyvsp[(1) - (1)].sval); }
    break;

  case 118:

/* Line 1810 of yacc.c  */
#line 534 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "action"); }
    break;

  case 119:

/* Line 1810 of yacc.c  */
#line 536 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "interpret"); }
    break;

  case 120:

/* Line 1810 of yacc.c  */
#line 538 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "type"); }
    break;

  case 121:

/* Line 1810 of yacc.c  */
#line 540 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "key"); }
    break;

  case 122:

/* Line 1810 of yacc.c  */
#line 542 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "group"); }
    break;

  case 123:

/* Line 1810 of yacc.c  */
#line 544 "src/xkbcomp/parser.y"
    {(yyval.sval) = xkb_atom_intern(param->ctx, "modifier_map");}
    break;

  case 124:

/* Line 1810 of yacc.c  */
#line 546 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "indicator"); }
    break;

  case 125:

/* Line 1810 of yacc.c  */
#line 548 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "shape"); }
    break;

  case 126:

/* Line 1810 of yacc.c  */
#line 550 "src/xkbcomp/parser.y"
    { (yyval.sval) = XKB_ATOM_NONE; }
    break;

  case 127:

/* Line 1810 of yacc.c  */
#line 552 "src/xkbcomp/parser.y"
    { (yyval.sval) = XKB_ATOM_NONE; }
    break;

  case 128:

/* Line 1810 of yacc.c  */
#line 554 "src/xkbcomp/parser.y"
    { (yyval.sval) = XKB_ATOM_NONE; }
    break;

  case 129:

/* Line 1810 of yacc.c  */
#line 557 "src/xkbcomp/parser.y"
    { (yyval.merge) = (yyvsp[(1) - (1)].merge); }
    break;

  case 130:

/* Line 1810 of yacc.c  */
#line 558 "src/xkbcomp/parser.y"
    { (yyval.merge) = MERGE_DEFAULT; }
    break;

  case 131:

/* Line 1810 of yacc.c  */
#line 561 "src/xkbcomp/parser.y"
    { (yyval.merge) = MERGE_DEFAULT; }
    break;

  case 132:

/* Line 1810 of yacc.c  */
#line 562 "src/xkbcomp/parser.y"
    { (yyval.merge) = MERGE_AUGMENT; }
    break;

  case 133:

/* Line 1810 of yacc.c  */
#line 563 "src/xkbcomp/parser.y"
    { (yyval.merge) = MERGE_OVERRIDE; }
    break;

  case 134:

/* Line 1810 of yacc.c  */
#line 564 "src/xkbcomp/parser.y"
    { (yyval.merge) = MERGE_REPLACE; }
    break;

  case 135:

/* Line 1810 of yacc.c  */
#line 566 "src/xkbcomp/parser.y"
    {
                    /*
                     * This used to be MERGE_ALT_FORM. This functionality was
                     * unused and has been removed.
                     */
                    (yyval.merge) = MERGE_DEFAULT;
                }
    break;

  case 136:

/* Line 1810 of yacc.c  */
#line 575 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 137:

/* Line 1810 of yacc.c  */
#line 576 "src/xkbcomp/parser.y"
    { (yyval.expr) = NULL; }
    break;

  case 138:

/* Line 1810 of yacc.c  */
#line 580 "src/xkbcomp/parser.y"
    { (yyval.expr) = (ExprDef *)AppendStmt(&(yyvsp[(1) - (3)].expr)->common, &(yyvsp[(3) - (3)].expr)->common); }
    break;

  case 139:

/* Line 1810 of yacc.c  */
#line 582 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 140:

/* Line 1810 of yacc.c  */
#line 586 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateBinary(EXPR_DIVIDE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 141:

/* Line 1810 of yacc.c  */
#line 588 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateBinary(EXPR_ADD, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 142:

/* Line 1810 of yacc.c  */
#line 590 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateBinary(EXPR_SUBTRACT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 143:

/* Line 1810 of yacc.c  */
#line 592 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateBinary(EXPR_MULTIPLY, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 144:

/* Line 1810 of yacc.c  */
#line 594 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateBinary(EXPR_ASSIGN, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 145:

/* Line 1810 of yacc.c  */
#line 596 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 146:

/* Line 1810 of yacc.c  */
#line 600 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateUnary(EXPR_NEGATE, (yyvsp[(2) - (2)].expr)->value_type, (yyvsp[(2) - (2)].expr)); }
    break;

  case 147:

/* Line 1810 of yacc.c  */
#line 602 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateUnary(EXPR_UNARY_PLUS, (yyvsp[(2) - (2)].expr)->value_type, (yyvsp[(2) - (2)].expr)); }
    break;

  case 148:

/* Line 1810 of yacc.c  */
#line 604 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateUnary(EXPR_NOT, EXPR_TYPE_BOOLEAN, (yyvsp[(2) - (2)].expr)); }
    break;

  case 149:

/* Line 1810 of yacc.c  */
#line 606 "src/xkbcomp/parser.y"
    { (yyval.expr) = ExprCreateUnary(EXPR_INVERT, (yyvsp[(2) - (2)].expr)->value_type, (yyvsp[(2) - (2)].expr)); }
    break;

  case 150:

/* Line 1810 of yacc.c  */
#line 608 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr);  }
    break;

  case 151:

/* Line 1810 of yacc.c  */
#line 610 "src/xkbcomp/parser.y"
    { (yyval.expr) = ActionCreate((yyvsp[(1) - (4)].sval), (yyvsp[(3) - (4)].expr)); }
    break;

  case 152:

/* Line 1810 of yacc.c  */
#line 612 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr);  }
    break;

  case 153:

/* Line 1810 of yacc.c  */
#line 614 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr);  }
    break;

  case 154:

/* Line 1810 of yacc.c  */
#line 618 "src/xkbcomp/parser.y"
    { (yyval.expr) = (ExprDef *)AppendStmt(&(yyvsp[(1) - (3)].expr)->common, &(yyvsp[(3) - (3)].expr)->common); }
    break;

  case 155:

/* Line 1810 of yacc.c  */
#line 620 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 156:

/* Line 1810 of yacc.c  */
#line 624 "src/xkbcomp/parser.y"
    { (yyval.expr) = ActionCreate((yyvsp[(1) - (4)].sval), (yyvsp[(3) - (4)].expr)); }
    break;

  case 157:

/* Line 1810 of yacc.c  */
#line 628 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_IDENT, EXPR_TYPE_UNKNOWN);
                            expr->value.str = (yyvsp[(1) - (1)].sval);
                            (yyval.expr) = expr;
                        }
    break;

  case 158:

/* Line 1810 of yacc.c  */
#line 635 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_FIELD_REF, EXPR_TYPE_UNKNOWN);
                            expr->value.field.element = (yyvsp[(1) - (3)].sval);
                            expr->value.field.field = (yyvsp[(3) - (3)].sval);
                            (yyval.expr) = expr;
                        }
    break;

  case 159:

/* Line 1810 of yacc.c  */
#line 643 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_ARRAY_REF, EXPR_TYPE_UNKNOWN);
                            expr->value.array.element = XKB_ATOM_NONE;
                            expr->value.array.field = (yyvsp[(1) - (4)].sval);
                            expr->value.array.entry = (yyvsp[(3) - (4)].expr);
                            (yyval.expr) = expr;
                        }
    break;

  case 160:

/* Line 1810 of yacc.c  */
#line 652 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_ARRAY_REF, EXPR_TYPE_UNKNOWN);
                            expr->value.array.element = (yyvsp[(1) - (6)].sval);
                            expr->value.array.field = (yyvsp[(3) - (6)].sval);
                            expr->value.array.entry = (yyvsp[(5) - (6)].expr);
                            (yyval.expr) = expr;
                        }
    break;

  case 161:

/* Line 1810 of yacc.c  */
#line 663 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_VALUE, EXPR_TYPE_STRING);
                            expr->value.str = (yyvsp[(1) - (1)].sval);
                            (yyval.expr) = expr;
                        }
    break;

  case 162:

/* Line 1810 of yacc.c  */
#line 670 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_VALUE, EXPR_TYPE_INT);
                            expr->value.ival = (yyvsp[(1) - (1)].ival);
                            (yyval.expr) = expr;
                        }
    break;

  case 163:

/* Line 1810 of yacc.c  */
#line 677 "src/xkbcomp/parser.y"
    {
                            (yyval.expr) = NULL;
                        }
    break;

  case 164:

/* Line 1810 of yacc.c  */
#line 681 "src/xkbcomp/parser.y"
    {
                            ExprDef *expr;
                            expr = ExprCreate(EXPR_VALUE, EXPR_TYPE_KEYNAME);
                            strncpy(expr->value.keyName, (yyvsp[(1) - (1)].keyName), 4);
                            (yyval.expr) = expr;
                        }
    break;

  case 165:

/* Line 1810 of yacc.c  */
#line 689 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 166:

/* Line 1810 of yacc.c  */
#line 690 "src/xkbcomp/parser.y"
    { (yyval.expr) = NULL; }
    break;

  case 167:

/* Line 1810 of yacc.c  */
#line 694 "src/xkbcomp/parser.y"
    { (yyval.expr) = AppendKeysymList((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].str)); }
    break;

  case 168:

/* Line 1810 of yacc.c  */
#line 696 "src/xkbcomp/parser.y"
    { (yyval.expr) = AppendMultiKeysymList((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr)); }
    break;

  case 169:

/* Line 1810 of yacc.c  */
#line 698 "src/xkbcomp/parser.y"
    { (yyval.expr) = CreateKeysymList((yyvsp[(1) - (1)].str)); }
    break;

  case 170:

/* Line 1810 of yacc.c  */
#line 700 "src/xkbcomp/parser.y"
    { (yyval.expr) = CreateMultiKeysymList((yyvsp[(1) - (1)].expr)); }
    break;

  case 171:

/* Line 1810 of yacc.c  */
#line 704 "src/xkbcomp/parser.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 172:

/* Line 1810 of yacc.c  */
#line 707 "src/xkbcomp/parser.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 173:

/* Line 1810 of yacc.c  */
#line 708 "src/xkbcomp/parser.y"
    { (yyval.str) = strdup("section"); }
    break;

  case 174:

/* Line 1810 of yacc.c  */
#line 710 "src/xkbcomp/parser.y"
    {
                            if ((yyvsp[(1) - (1)].ival) < 10) {      /* XK_0 .. XK_9 */
                                (yyval.str) = malloc(2);
                                (yyval.str)[0] = (yyvsp[(1) - (1)].ival) + '0';
                                (yyval.str)[1] = '\0';
                            }
                            else {
                                (yyval.str) = malloc(17);
                                snprintf((yyval.str), 17, "0x%x", (yyvsp[(1) - (1)].ival));
                            }
                        }
    break;

  case 175:

/* Line 1810 of yacc.c  */
#line 723 "src/xkbcomp/parser.y"
    { (yyval.ival) = -(yyvsp[(2) - (2)].ival); }
    break;

  case 176:

/* Line 1810 of yacc.c  */
#line 724 "src/xkbcomp/parser.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 177:

/* Line 1810 of yacc.c  */
#line 727 "src/xkbcomp/parser.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].num); }
    break;

  case 178:

/* Line 1810 of yacc.c  */
#line 728 "src/xkbcomp/parser.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].num) * XkbGeomPtsPerMM; }
    break;

  case 179:

/* Line 1810 of yacc.c  */
#line 731 "src/xkbcomp/parser.y"
    { (yyval.ival) = 0; }
    break;

  case 180:

/* Line 1810 of yacc.c  */
#line 734 "src/xkbcomp/parser.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].num); }
    break;

  case 181:

/* Line 1810 of yacc.c  */
#line 737 "src/xkbcomp/parser.y"
    { (yyval.uval) = (yyvsp[(1) - (1)].num); }
    break;

  case 182:

/* Line 1810 of yacc.c  */
#line 740 "src/xkbcomp/parser.y"
    { strncpy((yyval.keyName), (yyvsp[(1) - (1)].keyName), XkbKeyNameLength); }
    break;

  case 183:

/* Line 1810 of yacc.c  */
#line 743 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_steal(param->ctx, (yyvsp[(1) - (1)].str)); }
    break;

  case 184:

/* Line 1810 of yacc.c  */
#line 744 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_intern(param->ctx, "default"); }
    break;

  case 185:

/* Line 1810 of yacc.c  */
#line 747 "src/xkbcomp/parser.y"
    { (yyval.sval) = xkb_atom_steal(param->ctx, (yyvsp[(1) - (1)].str)); }
    break;

  case 186:

/* Line 1810 of yacc.c  */
#line 750 "src/xkbcomp/parser.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 187:

/* Line 1810 of yacc.c  */
#line 751 "src/xkbcomp/parser.y"
    { (yyval.str) = NULL; }
    break;

  case 188:

/* Line 1810 of yacc.c  */
#line 754 "src/xkbcomp/parser.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;



/* Line 1810 of yacc.c  */
#line 3435 "src/xkbcomp/parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, param, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, param, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, param);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, param);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, param, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, param);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, param);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2071 of yacc.c  */
#line 757 "src/xkbcomp/parser.y"


#undef scanner

